//
//  DeviceModel.h
//  BT-Aroma
//
//  Created by mqw on 2021/9/1.
//

#import <Foundation/Foundation.h>
#import "BGFMDB.h"

NS_ASSUME_NONNULL_BEGIN

//设备状态
typedef NS_ENUM(NSInteger, DeviceStatues) {
    DeviceStatues_Unkonw = 0,//未知
    DeviceStatues_Online = 1,//在线
    DeviceStatues_Conected = 2,//已连接
    DeviceStatues_Conecting = 3,//连接中
    DeviceStatues_Unconected = 4,//未连接
};

@interface DeviceModel : NSObject

@property (nonatomic, strong) NSString *macAddress;/**< 设备mac */
@property (nonatomic, strong) NSString *name;/**< 设备名称 */
@property (nonatomic, strong) NSNumber *RSSI;/**< 蓝牙信号 */
@property (nonatomic, assign) DeviceStatues status;/**< 设备连接状态 */
@property (nonatomic, strong) CBPeripheral *bleDevice;/**< 设备蓝牙 */
@property (nonatomic, strong) NSDictionary *bleDic;/**< 蓝牙广播数据 */
@property (nonatomic, assign) BOOL isOpen;/**< 运行状态 */
@property (nonatomic, assign) BOOL isLock;/**< 设备锁状态 */
@property (nonatomic, assign) int curweek;/**< 当前星期几 */
@property (nonatomic, assign) int hour;/**< 当前时间 小时 */
@property (nonatomic, assign) int minute;/**< 当前时间 分钟 */
@property (nonatomic, assign) int modeNum;/**< 当前工作模式编号 */
@property (nonatomic, assign) int runTime;/**< 当前运行时间 */
@property (nonatomic, assign) int pauseTime;/**< 当前暂停时间 */
@property (nonatomic, assign) int startHour;/**< 当前设备模式开始时间段 小时 */
@property (nonatomic, assign) int startMinute;/**< 当前设备模式开始时间段 分钟  */
@property (nonatomic, assign) int stopHour;/**< 当前设备模式结束时间段 小时 */
@property (nonatomic, assign) int stopMinute;/**< 当前设备模式结束时间段 分钟 */

/// data转16进制字符串
/// @param data 需要转换的data
+ (NSString *)convertDataToHexStr:(NSData *)data;

+ (NSData*)hexToData:(NSString *)hexString;

@end

NS_ASSUME_NONNULL_END
