//
//  ChangeServerView.m
//  B40-TestDemo
//
//  Created by mqw on 2021/10/25.
//

#import "ChangeServerView.h"
#import "MenuView.h"
#import "MenuModel.h"

@interface ChangeServerView ()
@property (nonatomic, strong) UIButton *serverButton;/**< 服务按钮 */
@property (nonatomic, strong) UILabel *readIDLabel;/**< <# 注释 #> */
@property (nonatomic, strong) UILabel *readPropertyLabel;/**< <# 注释 #> */
@property (nonatomic, strong) UILabel *writeIDLabel;/**< <# 注释 #> */
@property (nonatomic, strong) UILabel *writePropertyLabel;/**< <# 注释 #> */
@property (nonatomic, strong) UIButton *writeButton;/**< 写特征 按钮 */
@property (nonatomic, strong) UIButton *readButton;/**< 读特征 按钮 */
@property (nonatomic, strong) UIView *bgView;/**< <# 注释 #> */
@property (nonatomic, assign) NSInteger serverIndex;/**< <#注释#> */
@property (nonatomic, assign) NSInteger writeIndex;/**< <#注释#> */
@property (nonatomic, assign) NSInteger readIndex;/**< <#注释#> */
@property (nonatomic, strong) MenuView *myMenu;
@property (nonatomic, strong) NSArray *writeArray;/**< 写特征ID数组 */
@property (nonatomic, strong) NSArray *readArray;/**< 读特征ID数组 */

@end

@implementation ChangeServerView

- (instancetype)initWithFrame:(CGRect)frame {
    if ([super initWithFrame:frame]) {
        [self setUI];
    }
    return self;
}

- (void)setUI {
    self.bgView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight)];
    self.bgView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.5];
    [self addSubview:self.bgView];
    
    //容器
    UIView *contentView = [UIView new];
    contentView.backgroundColor = [UIColor whiteColor];
    contentView.layer.cornerRadius = 8.0;
    contentView.clipsToBounds = YES;
    [self.bgView addSubview:contentView];
    [contentView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(5);
        make.right.mas_equalTo(-5);
        make.height.mas_equalTo(350);
        make.centerY.mas_equalTo(self.bgView);
    }];
    
    //蓝牙服务
    UILabel *serverLabel = [UILabel new];
    serverLabel.text = @"蓝牙服务:";
    serverLabel.textColor = [UIColor blackColor];
    serverLabel.font = [UIFont systemFontOfSize:15];
    [contentView addSubview:serverLabel];
    [serverLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(17);
        make.top.mas_equalTo(25);
    }];
    
    //服务按钮
    self.serverButton = [UIButton new];
    [contentView addSubview:self.serverButton];
    self.serverButton.layer.borderWidth = 0.5;
    self.serverButton.layer.cornerRadius = 8.0;
    self.serverButton.layer.borderColor = [UIColor grayColor].CGColor;
    [self.serverButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    
//    serverButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
    [self.serverButton setImage:[UIImage imageNamed:@"img_up"] forState:UIControlStateNormal];
    self.serverButton.semanticContentAttribute = UISemanticContentAttributeForceRightToLeft;
    self.serverButton.titleLabel.font = [UIFont systemFontOfSize:15];
    [self.serverButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(30);
        make.top.mas_equalTo(serverLabel.mas_bottom).offset(4);
    }];
    [self.serverButton addTarget:self action:@selector(showServers) forControlEvents:UIControlEventTouchUpInside];
    

    
    UILabel *writeLabel = [UILabel new];
    writeLabel.text = @"特征,写:";
    writeLabel.textColor = [UIColor blackColor];
    writeLabel.font = [UIFont systemFontOfSize:15];
    [contentView addSubview:writeLabel];
    [writeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(17);
        make.top.mas_equalTo(self.serverButton.mas_bottom).offset(25);
    }];
    
    //写 特征ID
    self.writeIDLabel = [UILabel new];
    [contentView addSubview:self.writeIDLabel];
    self.writeIDLabel.textColor = [UIColor blackColor];
    self.writeIDLabel.text = @"";
    self.writeIDLabel.font = [UIFont systemFontOfSize:15];
    [self.writeIDLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(17);
        make.top.mas_equalTo(writeLabel.mas_bottom).offset(14);
    }];
    
    self.writePropertyLabel = [UILabel new];
    [contentView addSubview:self.writePropertyLabel];
    self.writePropertyLabel.text = @"";
    self.writePropertyLabel.textColor = [UIColor grayColor];
    self.writePropertyLabel.font = [UIFont systemFontOfSize:13];
    [self.writePropertyLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(13);
        make.top.mas_equalTo(self.writeIDLabel.mas_bottom).offset(6);
    }];
    


    
    
    self.writeButton = [UIButton new];
    [contentView addSubview:self.writeButton];
    self.writeButton.layer.borderWidth = 0.5;
    self.writeButton.layer.cornerRadius = 8.0;
    self.writeButton.layer.borderColor = [UIColor grayColor].CGColor;
    [self.writeButton setImage:[UIImage imageNamed:@"img_up"] forState:UIControlStateNormal];
    self.writeButton.semanticContentAttribute = UISemanticContentAttributeForceRightToLeft;
    self.writeButton.titleLabel.font = [UIFont systemFontOfSize:15];
    [self.writeButton setTitleColor:[UIColor clearColor] forState:UIControlStateNormal];
    [self.writeButton setTitle:@"02F00000-0000-0000-0000-00000000FF05" forState:UIControlStateNormal];
    [self.writeButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(50);
        make.top.mas_equalTo(writeLabel.mas_bottom).offset(4);
    }];
    [self.writeButton addTarget:self action:@selector(enterWriteButton) forControlEvents:UIControlEventTouchUpInside];
    
    //读, 特征
    UILabel *readLabel = [UILabel new];
    readLabel.text = @"特征,读:";
    readLabel.textColor = [UIColor blackColor];
    readLabel.font = [UIFont systemFontOfSize:15];
    [contentView addSubview:readLabel];
    [readLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(17);
        make.top.mas_equalTo(self.writeButton.mas_bottom).offset(25);
    }];
    
    //读 特征ID
    self.readIDLabel = [UILabel new];
    [contentView addSubview:self.readIDLabel];
    self.readIDLabel.text = @"";
    self.readIDLabel.textColor = [UIColor blackColor];
    self.readIDLabel.font = [UIFont systemFontOfSize:15];
    [self.readIDLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(17);
        make.top.mas_equalTo(readLabel.mas_bottom).offset(14);
    }];
    
    self.readPropertyLabel = [UILabel new];
    [contentView addSubview:self.readPropertyLabel];
    self.readPropertyLabel.text = @"";
    self.readPropertyLabel.textColor = [UIColor grayColor];
    self.readPropertyLabel.font = [UIFont systemFontOfSize:13];
    [self.readPropertyLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(13);
        make.top.mas_equalTo(self.readIDLabel.mas_bottom).offset(6);
    }];
    

    
    
    self.readButton = [UIButton new];
    [contentView addSubview:self.readButton];
    self.readButton.layer.borderWidth = 0.5;
    self.readButton.layer.cornerRadius = 8.0;
    self.readButton.layer.borderColor = [UIColor grayColor].CGColor;
    [self.readButton setImage:[UIImage imageNamed:@"img_up"] forState:UIControlStateNormal];
    self.readButton.semanticContentAttribute = UISemanticContentAttributeForceRightToLeft;
    self.readButton.titleLabel.font = [UIFont systemFontOfSize:15];
    [self.readButton setTitleColor:[UIColor clearColor] forState:UIControlStateNormal];
    [self.readButton setTitle:@"02F00000-0000-0000-0000-00000000FF05" forState:UIControlStateNormal];
    [self.readButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(8);
        make.right.mas_equalTo(-8);
        make.height.mas_equalTo(50);
        make.top.mas_equalTo(readLabel.mas_bottom).offset(4);
    }];
    [self.readButton addTarget:self action:@selector(enterReadButton) forControlEvents:UIControlEventTouchUpInside];
    
    
    //横线
    UILabel *lineLabel = [UILabel new];
    lineLabel.backgroundColor = [UIColor grayColor];
    [contentView addSubview:lineLabel];
    [lineLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.height.mas_equalTo(0.5);
        make.bottom.mas_equalTo(-40);
    }];
    
    //竖线
    UILabel *line2Label = [UILabel new];
    line2Label.backgroundColor = [UIColor grayColor];
    [contentView addSubview:line2Label];
    [line2Label mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(lineLabel.mas_bottom);
        make.width.mas_equalTo(0.5);
        make.centerX.mas_equalTo(contentView);
        make.bottom.mas_equalTo(0);
    }];
    
    UIButton *cancelButton = [UIButton new];
    [cancelButton setTitle:@"取消" forState:UIControlStateNormal];
    [contentView addSubview:cancelButton];
    [cancelButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [cancelButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(line2Label.mas_left);
        make.bottom.mas_equalTo(0);
        make.top.mas_equalTo(lineLabel.mas_bottom);
    }];
    [cancelButton addTarget:self action:@selector(hidenSelf) forControlEvents:UIControlEventTouchUpInside];
    
    
    UIButton *confirmationButton = [UIButton new];
    [confirmationButton setTitle:@"确定" forState:UIControlStateNormal];
    [contentView addSubview:confirmationButton];
    [confirmationButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [confirmationButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(line2Label.mas_right);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.top.mas_equalTo(lineLabel.mas_bottom);
    }];
    [confirmationButton addTarget:self action:@selector(enterConfirmationButton) forControlEvents:UIControlEventTouchUpInside];

    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(hiddenMenu:)];
    [self.bgView addGestureRecognizer:tap];
}

- (void)hidenSelf {
    [self removeFromSuperview];
}

- (void)showServers {
    [_myMenu removeFromSuperview];
    
    NSLog(@"哈哈哈,我被按了一下");
    //服务列表
    NSMutableArray *dataArray = [NSMutableArray array];
    for (int i = 0; i < self.bleDevice.services.count; i++) {
        CBService *server = self.bleDevice.services[i];
        MenuModel *model = [MenuModel new];
        model.title = [server.UUID UUIDString];
        model.subTitle = @"Server";
        [dataArray addObject:model];
    }
    
    CGRect frame = [self.serverButton.superview convertRect:self.serverButton.frame toView:self];
    self.myMenu = [[MenuView alloc]initWithFrame:CGRectMake(frame.origin.x, frame.origin.y, frame.size.width - 28, dataArray.count*50) andDataSource:dataArray];
    self.myMenu.tag = 1000;
    self.myMenu.layer.shadowColor = [UIColor lightGrayColor].CGColor;
    self.myMenu.layer.shadowOffset = CGSizeMake(0,0.5);
    self.myMenu.layer.shadowOpacity = 0.6;
    self.myMenu.layer.shadowRadius = 1.0;
    self.myMenu.clipsToBounds = NO;
    [self addSubview:self.myMenu];
    
    WS(weakSelf);
    self.myMenu.clickBlock = ^(NSInteger currentIndex, NSInteger tag) {
        NSLog(@"看看我点击了第%ld行, tag====%ld",currentIndex,tag);
        if (weakSelf.serverIndex != currentIndex) {
            weakSelf.serverIndex = currentIndex;
            weakSelf.server = weakSelf.bleDevice.services[currentIndex];
            
            [weakSelf.serverButton setTitle:[weakSelf.server.UUID UUIDString] forState:UIControlStateNormal];
            
            [weakSelf creatWriteArray];
            if (weakSelf.writeArray.count > 0) {
                MenuModel *model = weakSelf.writeArray[0];
                weakSelf.writeIDLabel.text = model.title;
                weakSelf.writePropertyLabel.text = model.subTitle;
            }else {
                weakSelf.writeIDLabel.text = @"";
                weakSelf.writePropertyLabel.text = @"";
            }
            
            [weakSelf creatReadArray];
            if (weakSelf.readArray.count > 0) {
                MenuModel *readModel = weakSelf.readArray[0];
                weakSelf.readIDLabel.text = readModel.title;
                weakSelf.readPropertyLabel.text = readModel.subTitle;
            }else {
                weakSelf.readIDLabel.text = @"";
                weakSelf.readPropertyLabel.text = @"";
            }
        }
        
        [weakSelf.myMenu removeFromSuperview];
    };
}

- (void)creatWriteArray {
    NSMutableArray *dataArray = [NSMutableArray array];
//    CBService *server = self.bleDevice.services[_serverIndex];
    for (int i = 0;i < self.server.characteristics.count; i++ ) {
        CBCharacteristic *cha = self.server.characteristics[i];
        MenuModel *model = [MenuModel new];
        model.title = [cha.UUID UUIDString];
        model.subTitle = @"";
        
        if(cha.properties & CBCharacteristicPropertyWrite || cha.properties & CBCharacteristicPropertyWriteWithoutResponse){
            if (cha.properties & CBCharacteristicPropertyWrite) {
                model.subTitle = @"[PROPERTY_WRITE]";
            }
            if (cha.properties & CBCharacteristicPropertyWriteWithoutResponse) {
                model.subTitle = [NSString stringWithFormat:@"%@[PROPERTY_WRITE_NO_RESPONSE]",model.subTitle];
            }
            [dataArray addObject:model];
        }
    }
    self.writeArray = [NSArray arrayWithArray:dataArray];
}

- (void)creatReadArray {
    NSMutableArray *dataArray = [NSMutableArray array];
//    self.server = self.bleDevice.services[_serverIndex];
    for (int i = 0;i < self.server.characteristics.count; i++ ) {
        CBCharacteristic *cha = self.server.characteristics[i];
        MenuModel *model = [MenuModel new];
        model.title = [cha.UUID UUIDString];
        model.subTitle = @"";
        
        if(cha.properties & CBCharacteristicPropertyRead || cha.properties & CBCharacteristicPropertyNotify){
            if (cha.properties & CBCharacteristicPropertyRead) {
                model.subTitle = @"[PROPERTY_READ]";
            }
            if (cha.properties & CBCharacteristicPropertyWriteWithoutResponse) {
                model.subTitle = [NSString stringWithFormat:@"%@[PROPERTY_NOTIFY]",model.subTitle];
            }
            [dataArray addObject:model];
        }
    }
    self.readArray = [NSArray arrayWithArray:dataArray];
}

- (void)hiddenMenu:(UITapGestureRecognizer *)sender {
    UIView *view = sender.view;
    NSInteger num = view.tag;
    if (num == 1000 || num == 2000 || num == 300) {
        return;
    }
    [_myMenu removeFromSuperview];
}

- (void)enterWriteButton {
    [_myMenu removeFromSuperview];
    //写特征列表
    CGRect frame = [self.writeButton.superview convertRect:self.writeButton.frame toView:self];
    _myMenu = [[MenuView alloc]initWithFrame:CGRectMake(frame.origin.x, frame.origin.y, frame.size.width - 28, self.writeArray.count*50) andDataSource:self.writeArray];
    _myMenu.tag = 2000;
    _myMenu.layer.shadowColor = [UIColor lightGrayColor].CGColor;
    _myMenu.layer.shadowOffset = CGSizeMake(0,0.5);
    _myMenu.layer.shadowOpacity = 0.6;
    _myMenu.layer.shadowRadius = 1.0;
    _myMenu.clipsToBounds = NO;
    [self addSubview:_myMenu];
    
    WS(weakSelf);
    _myMenu.clickBlock = ^(NSInteger currentIndex, NSInteger tag) {
        NSLog(@"看看我点击了第%ld行, tag====%ld",currentIndex,tag);
        MenuModel *model = weakSelf.writeArray[currentIndex];
        weakSelf.writeIDLabel.text = model.title;
        weakSelf.writePropertyLabel.text = model.subTitle;
        [weakSelf.myMenu removeFromSuperview];
    };
}


- (void)enterReadButton {
    [_myMenu removeFromSuperview];
    
    //读特征列表
    CGRect frame = [self.readButton.superview convertRect:self.readButton.frame toView:self];
    _myMenu = [[MenuView alloc]initWithFrame:CGRectMake(frame.origin.x, frame.origin.y, frame.size.width - 28, self.readArray.count*50) andDataSource:self.readArray];
    _myMenu.tag = 2000;
    _myMenu.layer.shadowColor = [UIColor lightGrayColor].CGColor;
    _myMenu.layer.shadowOffset = CGSizeMake(0,0.5);
    _myMenu.layer.shadowOpacity = 0.6;
    _myMenu.layer.shadowRadius = 1.0;
    _myMenu.clipsToBounds = NO;
    [self addSubview:_myMenu];
    
    WS(weakSelf);
    _myMenu.clickBlock = ^(NSInteger currentIndex, NSInteger tag) {
        NSLog(@"看看我点击了第%ld行, tag====%ld",currentIndex,tag);
        MenuModel *model = weakSelf.readArray[currentIndex];
        weakSelf.readIDLabel.text = model.title;
        weakSelf.readPropertyLabel.text = model.subTitle;
        [weakSelf.myMenu removeFromSuperview];
    };
}

-(void)setServer:(CBService *)server {
    for (int i = 0; i < self.bleDevice.services.count; i++) {
        if ([server isEqual:self.bleDevice.services[i]]) {
            self.serverIndex = i;
        }
    }
    _server = server;
    [self creatReadArray];
    [self creatWriteArray];
    [self.serverButton setTitle:[server.UUID UUIDString] forState:UIControlStateNormal];
    
    
    if (self.readArray.count > 0) {
        for (int i = 0; i < self.readArray.count; i++) {
            MenuModel *model = self.readArray[i];
            if ([[self.characteristicRead.UUID UUIDString] isEqualToString:model.title]) {
                self.readIDLabel.text = model.title;
                self.readPropertyLabel.text = model.subTitle;
            }
        }
    }
    
    if (self.writeArray.count > 0) {
        for (int i = 0; i < self.writeArray.count; i++) {
            MenuModel *model = self.writeArray[i];
            if ([[self.characteristicWrite.UUID UUIDString] isEqualToString:model.title]) {
                self.writeIDLabel.text = model.title;
                self.writePropertyLabel.text = model.subTitle;
            }
        }
    }
}

//点击确定按钮  更换服务
- (void)enterConfirmationButton {
    if (self.changeBlock) {
        [self hidenSelf];
        
        if (![self.readIDLabel.text isEqualToString:@""]) {
            for (int i = 0; i < self.server.characteristics.count; i++) {
                CBCharacteristic *cha = self.server.characteristics[i];
                if ([[cha.UUID UUIDString] isEqualToString:self.readIDLabel.text]) {
                    self.characteristicRead = cha;
                }
            }
        }else {
            self.characteristicRead = nil;
        }

        if (![self.writeIDLabel.text isEqualToString:@""]) {
            for (int i = 0; i < self.server.characteristics.count; i++) {
                CBCharacteristic *cha = self.server.characteristics[i];
                if ([[cha.UUID UUIDString] isEqualToString:self.writeIDLabel.text]) {
                    self.characteristicWrite = cha;
                }
            }
        }else {
            self.characteristicWrite = nil;
        }
        
        self.changeBlock(self.server, self.characteristicRead, self.characteristicWrite);
    }
}

@end
