//
//  MenuView.m
//  B40-TestDemo
//
//  Created by mqw on 2021/10/26.
//

#import "MenuView.h"
#import "MenuCell.h"

@interface MenuView ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong) UITableView *tableView;/**< <# 注释 #> */
@property (nonatomic, strong) NSArray *dataArray;/**< 数据源 */

@end

@implementation MenuView

- (instancetype)initWithFrame:(CGRect)frame andDataSource:(NSArray *)dataSource {
    if ([super initWithFrame:frame]) {
        self.dataArray = [NSArray arrayWithArray:dataSource];
        [self setUIWithFrame:frame];
    }
    
    return self;
}

- (void)setUIWithFrame:(CGRect)frame {
    
    //tableView
    self.tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, self.frame.size.width, self.frame.size.height) style:UITableViewStylePlain];
    self.tableView.scrollEnabled = NO;
    if (self.dataArray.count > 4) {
        self.tableView.frame = CGRectMake(0, 0, self.frame.size.width, 200);
        self.tableView.scrollEnabled = YES;
    }
    self.tableView.backgroundColor = [UIColor clearColor];
    [self.tableView registerNib:[UINib nibWithNibName:@"MenuCell" bundle:nil] forCellReuseIdentifier:@"MenuCell"];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [self addSubview:self.tableView];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.dataArray.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 50;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    MenuCell *cell = [self.tableView dequeueReusableCellWithIdentifier:@"MenuCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleBlue;
    [cell setUIWithModel:self.dataArray[indexPath.row]];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
//    NSLog(@"==========%ld",(long)indexPath.row);
    if (self.clickBlock) {
        self.clickBlock(indexPath.row, self.tag);
    }
}

@end
