//
//  ShortcutInstructionsCell.m
//  B40-TestDemo
//
//  Created by mqw on 2021/11/25.
//

#import "ShortcutInstructionsCell.h"
#import "ZZW_Tool.h"

@interface ShortcutInstructionsCell ()

@property (weak, nonatomic) IBOutlet UILabel *titleLabel;
@property (weak, nonatomic) IBOutlet UILabel *contentLabel;


@end

@implementation ShortcutInstructionsCell

- (void)awakeFromNib {
    [super awakeFromNib];
    
    UILongPressGestureRecognizer *longPress = [[UILongPressGestureRecognizer alloc] initWithTarget:self action:@selector(handleLongPressGuesture:)];
    [self.contentView addGestureRecognizer:longPress];
}
- (void)handleLongPressGuesture:(UILongPressGestureRecognizer *)guesture {
    if (self.deleteBlock) {
        self.deleteBlock(self.tag);
    }
}

- (void)setUIWithModel:(InstructionModel *)model {
    self.titleLabel.text = [NSString stringWithFormat:@"%ld.  %@",self.tag+1,model.name];
    self.contentLabel.text = [NSString stringWithFormat:@"command: %@",model.content];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
