//
//  ZZW_Tool.m
//  BT-Aroma
//
//  Created by mqw on 2021/9/7.
//

#import "ZZW_Tool.h"

@implementation ZZW_Tool

+ (CGFloat)getStringHeightWithText:(NSString *)text font:(UIFont *)font viewWidth:(CGFloat)width {
    // 设置文字属性 要和label的一致
    NSDictionary *attrs = @{NSFontAttributeName :font};
    CGSize maxSize = CGSizeMake(width, MAXFLOAT);
    
    NSStringDrawingOptions options = NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading;
    
    // 计算文字占据的宽高
    CGSize size = [text boundingRectWithSize:maxSize options:options attributes:attrs context:nil].size;
    
    // 当你是把获得的高度来布局控件的View的高度的时候.size转化为ceilf(size.height)。
    return  ceilf(size.height);
}


+ (CGFloat)getStringWidthWithText:(NSString *)text font:(UIFont *)font viewHeight:(CGFloat)height {
    // 设置文字属性 要和label的一致
    NSDictionary *attrs = @{NSFontAttributeName :font};
    CGSize maxSize = CGSizeMake(MAXFLOAT, height);
    
    NSStringDrawingOptions options = NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading;
    
    // 计算文字占据的宽高
    CGSize size = [text boundingRectWithSize:maxSize options:options attributes:attrs context:nil].size;
    
    // 当你是把获得的高度来布局控件的View的高度的时候.size转化为ceilf(size.height)。
    return  ceilf(size.width);
}

+ (NSString *)ZZW_weekdaySortWithDayArray:(NSArray *)array {

    NSArray *titleArr = @[@"Mon",@"Tue",@"Wed",@"Thu",@"Fri",@"Sat",@"Sun"];

    NSArray *wholeArr = @[@"1",@"2",@"3",@"4",@"5",@"6",@"7"];

    NSString *wholeStr = [wholeArr componentsJoinedByString:@""];

    NSArray *unSeleccArr = [wholeArr filteredArrayUsingPredicate:[NSPredicate predicateWithFormat:@"NOT (SELF in %@)", array]];

    NSString *unSelectStr = [unSeleccArr componentsJoinedByString:@""];

    NSArray *sortArr = [wholeStr componentsSeparatedByCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:unSelectStr]];

    NSMutableArray *array1 = [NSMutableArray arrayWithArray:sortArr];

    [array1 removeObject:@""];

    NSMutableArray *goalArr;

    for (NSString *subStr in array1) {

        NSString *str1;

        if (subStr.length > 1) {
            str1 = [self reGetArrayWithString:subStr];
        } else {
            str1 = NSLocalizedString(titleArr[[subStr integerValue]-1], @"周一...周日");
        }

        if (!goalArr) {
            goalArr = [NSMutableArray array];
        }

        [goalArr addObject:str1];

    }

    NSString *finalStr = [goalArr componentsJoinedByString:@" "];

    return finalStr;

}

//array表示输入的选定的日期

+ (NSString *)reGetArrayWithString:(NSString *)string {

    NSArray *titleArr = @[@"Mon",@"Tue",@"Wed",@"Thu",@"Fri",@"Sat",@"Sun"];

    NSString *topStr = [string substringToIndex:1];

    NSString *bottomStr = [string substringFromIndex:string.length-1];

    NSString *goalStr;

    if (string.length >= 3) {
        goalStr = [NSString stringWithFormat:@"%@%@%@",NSLocalizedString(titleArr[[topStr integerValue]-1], @"周一...周日"), NSLocalizedString(@"zhi", @"至"), NSLocalizedString(titleArr[[bottomStr integerValue]-1], @"周一...周日")];

    } else {
        goalStr = [NSString stringWithFormat:@"%@ %@",NSLocalizedString(titleArr[[topStr integerValue]-1], @"周一...周日"),NSLocalizedString(titleArr[[bottomStr integerValue]-1], @"周一...周日")];

    }

    return goalStr;

}

@end
