//
//  DeviceInfHelper.m
//  Qkeeper
//
//  Created by mqw on 15/11/9.
//  Copyright © 2015年 mqw. All rights reserved.
//

#import "MyDeviceInfHelper.h"
#import <SystemConfiguration/SystemConfiguration.h>
#import <SystemConfiguration/CaptiveNetwork.h>




@implementation MyDeviceInfHelper
{
    Boolean isinit;
}
- (id)init {
    self = [super init];
    if (self) {
        _recvLocalCommandStrDic  = [[NSMutableDictionary alloc]initWithCapacity:0];
        _recvRemoteCommandStrDic = [[NSMutableDictionary alloc]initWithCapacity:0];
    }
    return self;
}


+ (instancetype)sharedClient {
    static MyDeviceInfHelper *helper = nil;
    static dispatch_once_t onceToken;
    
    dispatch_once(&onceToken, ^{
        helper = [[self alloc] init];
    });
    return helper;
}








/**
 二进制转换成十六进制
 
 @param binary 二进制数
 @return 十六进制数
 */
+ (NSString *)getHexByBinary:(NSString *)binary {
    
    NSMutableDictionary *binaryDic = [[NSMutableDictionary alloc] initWithCapacity:16];
    [binaryDic setObject:@"0" forKey:@"0000"];
    [binaryDic setObject:@"1" forKey:@"0001"];
    [binaryDic setObject:@"2" forKey:@"0010"];
    [binaryDic setObject:@"3" forKey:@"0011"];
    [binaryDic setObject:@"4" forKey:@"0100"];
    [binaryDic setObject:@"5" forKey:@"0101"];
    [binaryDic setObject:@"6" forKey:@"0110"];
    [binaryDic setObject:@"7" forKey:@"0111"];
    [binaryDic setObject:@"8" forKey:@"1000"];
    [binaryDic setObject:@"9" forKey:@"1001"];
    [binaryDic setObject:@"A" forKey:@"1010"];
    [binaryDic setObject:@"B" forKey:@"1011"];
    [binaryDic setObject:@"C" forKey:@"1100"];
    [binaryDic setObject:@"D" forKey:@"1101"];
    [binaryDic setObject:@"E" forKey:@"1110"];
    [binaryDic setObject:@"F" forKey:@"1111"];
    
    if (binary.length % 4 != 0) {
        
        NSMutableString *mStr = [[NSMutableString alloc]init];;
        for (int i = 0; i < 4 - binary.length % 4; i++) {
            
            [mStr appendString:@"0"];
        }
        binary = [mStr stringByAppendingString:binary];
    }
    NSString *hex = @"";
    for (int i=0; i<binary.length; i+=4) {
        
        NSString *key = [binary substringWithRange:NSMakeRange(i, 4)];
        NSString *value = [binaryDic objectForKey:key];
        if (value) {
            
            hex = [hex stringByAppendingString:value];
        }
    }
    return hex;
}


+ (NSData*)hexToData:(NSString *)hexString {
    
    NSUInteger len = hexString.length / 2;
    const char *hexCode = [hexString UTF8String];
    char * bytes = (char *)malloc(len);
    
    char *pos = (char *)hexCode;
    for (NSUInteger i = 0; i < hexString.length / 2; i++) {
        sscanf(pos, "%2hhx", &bytes[i]);
        pos += 2 * sizeof(char);
    }
    
    NSData * data = [[NSData alloc] initWithBytes:bytes length:len];
    
    free(bytes);
    return data;
}

+(NSString *)getBinaryByhex:(NSString *)hex
{
    hex = [hex uppercaseString];
    NSMutableDictionary  *hexDic = [[NSMutableDictionary alloc] init];
    hexDic = [[NSMutableDictionary alloc] initWithCapacity:16];
    [hexDic setObject:@"0000" forKey:@"0"];
    [hexDic setObject:@"0001" forKey:@"1"];
    [hexDic setObject:@"0010" forKey:@"2"];
    [hexDic setObject:@"0011" forKey:@"3"];
    [hexDic setObject:@"0100" forKey:@"4"];
    [hexDic setObject:@"0101" forKey:@"5"];
    [hexDic setObject:@"0110" forKey:@"6"];
    [hexDic setObject:@"0111" forKey:@"7"];
    [hexDic setObject:@"1000" forKey:@"8"];
    [hexDic setObject:@"1001" forKey:@"9"];
    [hexDic setObject:@"1010" forKey:@"A"];
    [hexDic setObject:@"1011" forKey:@"B"];
    [hexDic setObject:@"1100" forKey:@"C"];
    [hexDic setObject:@"1101" forKey:@"D"];
    [hexDic setObject:@"1110" forKey:@"E"];
    [hexDic setObject:@"1111" forKey:@"F"];
    NSMutableString *binaryString=[[NSMutableString alloc] init];
    for (int i=0; i<[hex length]; i++) {
        NSRange rage;
        rage.length = 1;
        rage.location = i;
        NSString *key = [hex substringWithRange:rage];
        NSString *temp2 = [NSString stringWithFormat:@"%@",[hexDic objectForKey:key]];
        [binaryString appendString:temp2];
        
    }
    //NSLog(@"转化后的二进制为:%@",binaryString);
    return binaryString;
}


#pragma mark 解析外网内接收到的数据
-(void) parseRemoteDataWithDeviceID:(NSData*)recvData withDevice:(NSString*)iotID{
    @synchronized(self) {
          
      NSString*deviceID = iotID;
        NSString *result =[self convertDataToHexStr:recvData];
        if(result == nil)
            return;
        NSMutableString *commandStr = [_recvRemoteCommandStrDic objectForKey:deviceID];
        if (commandStr==nil) {
            commandStr = [[NSMutableString alloc] initWithString:@""];
        }
        NSLog(@"----------------------------远程接收到设备：%@ 数据：%@",deviceID,result);
        [commandStr appendString:result];
        
        NSLog(@"----------------------------远程待处理设备：%@ 数据：%@",deviceID,commandStr);
        [_recvRemoteCommandStrDic setObject:commandStr forKey:deviceID];
        Boolean isFindHeader = NO;
        while (commandStr.length > 0) {
            
            NSRange start = [commandStr rangeOfString:COMMAND_HEAD];
            if (start.length == 0 ) {
                isFindHeader = NO;
                //如果不是我们需要的数据  不存储
                [_recvRemoteCommandStrDic removeObjectForKey:deviceID];
                break;
            }else{
                isFindHeader = YES;
                [commandStr deleteCharactersInRange:NSMakeRange(0,start.location)];
                [_recvRemoteCommandStrDic setObject:commandStr forKey:deviceID];
            }
            NSRange end   = [commandStr rangeOfString:COMMAND_END];
            if (end.length == 0 ) {
                break;
            }
            NSInteger loc    = 0;
            NSInteger length = end.location + end.length;
            NSString*resultValue =  [commandStr substringWithRange:NSMakeRange(loc,length)];
            
            
            NSMutableString *commandStrT = [[NSMutableString alloc] initWithString:resultValue];
            NSRange startT = [commandStrT rangeOfString:COMMAND_HEAD];
            [commandStrT deleteCharactersInRange:startT];
            //校验码
            NSString *B2= [commandStrT substringWithRange:NSMakeRange(0,2)];
            //指令类型
            NSString*B3 = [commandStrT substringWithRange:NSMakeRange(2,2)];
            //指令
            NSString*B4 = [commandStrT substringWithRange:NSMakeRange(4,2)];
            //参数
            NSString*B5 = [commandStrT substringWithRange:NSMakeRange(6,commandStrT.length-6-6)];
            //计算校验码
            NSMutableString *tempStr = [[NSMutableString alloc] initWithString:B3];
            [tempStr appendString:B4];
            [tempStr appendString:B5];
            NSData*commandPacket = [self hexToBytes:tempStr];
            NSString*bCheck = [NSString stringWithFormat:@"%02x",[self singleDog:commandPacket]];
            if([bCheck intValue] != [B2 intValue])
            {
                NSLog(@"<<<<<<<<<<<<<<<<<<<<远程接收校验失败！！！！！移除包头>>>>>>>>>>>>>>");
                [commandStr deleteCharactersInRange:NSMakeRange(loc,3)];
                [_recvRemoteCommandStrDic setObject:commandStr forKey:deviceID];
                NSLog(@"---------------------远程剩余待处理数据：%@",commandStr);
                
                
            }else{
                [commandStr deleteCharactersInRange:NSMakeRange(loc,length)];
                [_recvRemoteCommandStrDic setObject:commandStr forKey:deviceID];
                NSLog(@"---------------------远程剩余待处理数据：%@",commandStr);
                NSDictionary *dic = [[NSDictionary alloc] initWithObjectsAndKeys:B3, @"B3", B4, @"B4", B5,@"B5" ,nil];
                 //解析数据
                [self  doParseWork:dic withDevice:deviceID withType:666];
            }
            isFindHeader = NO;
            continue;
        }
    }
}


#pragma mark 解析局域网内接收到的数据
-(void) parseLocalDataWithDeviceID:(NSData*)recvData withDevice:(NSString*)iotID{
    @synchronized(self) {
          
      NSString*deviceID = iotID;
        NSString *result =[self convertDataToHexStr:recvData];
        if(result == nil)
            return;
        NSMutableString *commandStr = [_recvLocalCommandStrDic objectForKey:deviceID];
        if (commandStr==nil) {
            commandStr = [[NSMutableString alloc] initWithString:@""];
        }
        NSLog(@"----------------------------远程接收到设备：%@ 数据：%@",deviceID,result);
        [commandStr appendString:result];
        
        NSLog(@"----------------------------远程待处理设备：%@ 数据：%@",deviceID,commandStr);
        [_recvLocalCommandStrDic setObject:commandStr forKey:deviceID];
        Boolean isFindHeader = NO;
        while (commandStr.length > 0) {
            
            NSRange start = [commandStr rangeOfString:COMMAND_HEAD];
            if (start.length == 0 ) {
                isFindHeader = NO;
                //如果不是我们需要的数据  不存储
                [_recvLocalCommandStrDic removeObjectForKey:deviceID];
                break;
            }else{
                isFindHeader = YES;
                [commandStr deleteCharactersInRange:NSMakeRange(0,start.location)];
                [_recvLocalCommandStrDic setObject:commandStr forKey:deviceID];
            }
            NSRange end   = [commandStr rangeOfString:COMMAND_END];
            if (end.length == 0 ) {
                break;
            }
            NSInteger loc    = 0;
            NSInteger length = end.location + end.length;
            NSString*resultValue =  [commandStr substringWithRange:NSMakeRange(loc,length)];
            
            
            NSMutableString *commandStrT = [[NSMutableString alloc] initWithString:resultValue];
            NSRange startT = [commandStrT rangeOfString:COMMAND_HEAD];
            [commandStrT deleteCharactersInRange:startT];
            //校验码
            NSString *B2= [commandStrT substringWithRange:NSMakeRange(0,2)];
            //指令类型
            NSString*B3 = [commandStrT substringWithRange:NSMakeRange(2,2)];
            //指令
            NSString*B4 = [commandStrT substringWithRange:NSMakeRange(4,2)];
            //参数
            NSString*B5 = [commandStrT substringWithRange:NSMakeRange(6,commandStrT.length-6-6)];
            //计算校验码
            NSMutableString *tempStr = [[NSMutableString alloc] initWithString:B3];
            [tempStr appendString:B4];
            [tempStr appendString:B5];
            NSData*commandPacket = [self hexToBytes:tempStr];
            NSString*bCheck = [NSString stringWithFormat:@"%02x",[self singleDog:commandPacket]];
            if([bCheck intValue] != [B2 intValue])
            {
                NSLog(@"<<<<<<<<<<<<<<<<<<<<远程接收校验失败！！！！！移除包头>>>>>>>>>>>>>>");
                [commandStr deleteCharactersInRange:NSMakeRange(loc,3)];
                [_recvLocalCommandStrDic setObject:commandStr forKey:deviceID];
                NSLog(@"---------------------远程剩余待处理数据：%@",commandStr);
                
                
            }else{
                [commandStr deleteCharactersInRange:NSMakeRange(loc,length)];
                [_recvLocalCommandStrDic setObject:commandStr forKey:deviceID];
                NSLog(@"---------------------远程剩余待处理数据：%@",commandStr);
                NSDictionary *dic = [[NSDictionary alloc] initWithObjectsAndKeys:B3, @"B3", B4, @"B4", B5,@"B5" ,nil];
                 //解析数据
                [self  doParseWork:dic withDevice:deviceID withType:555];
            }
            isFindHeader = NO;
            continue;
        }
    }
}

-(void)doParseWork:(NSDictionary*)commandDic withDevice:(NSString*)iotID withType:(int)Type {
    
    //指令类型
    NSString*B3 = [commandDic objectForKey:@"B3"];
    //指令
    NSString*B4 = [commandDic objectForKey:@"B4"];
    //参数
    NSString*B5 = [commandDic objectForKey:@"B5"];
    NSDictionary*dic = nil;
    long type =(long)strtoul([B3 UTF8String],0,16);
    long command =(long)strtoul([B4 UTF8String],0,16);
    
    
    switch (type) {
        case 'R':
            switch (command) {
                case 0X00://获取：恢复出厂设置
                    NSLog(@"获取到主机恢复出厂设置：%@",B5);
                    break;
                case 0X01://主机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceState:B5]];
                    NSLog(@"获取到主机状态信息：%@",dic);
                }
                    break;
                case 0X02://主机时间
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceTime:B5]];
                    NSLog(@"获取到主机时间：%@",dic);
                }
                    break;
                case 0X03://风扇开关状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceFan:B5 withCommandType:0x03]];
                    NSLog(@"风扇开关状态：%@",dic);
                }
                    break;
                case 0X04://可用天数
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceAvailables:B5]];
                    NSLog(@"获取到负离子开关状态：%@",dic);
                }
                    break;
                case 0X05://精油配置参数
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceEssential:B5]];
                    NSLog(@"获取到主机精油状态：%@",dic);
                }
                    break;
                case 0X06://工作模式设定信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkGap:B5]];
                    NSLog(@"获取到主机工作时间段设定信息：%@",dic);
                }
                    break;
                case 0X07://工作档位
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceGears:B5]];
                    NSLog(@"获取到主机工作档位：%@",dic);
                }
                    break;
                case 0X08://开关机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceOnOFF:B5 withCommandType:0x08]];
                    NSLog(@"获取到主机开关机信息：%@",dic);
                }
                    break;
                    
                case 0X09://设备锁状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceLockState:B5]];
                    NSLog(@"获取到主机开关机信息：%@",dic);
                }
                    break;
                    
                case 0X0a://工作状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkState:B5]];
                    NSLog(@"获取到主机工作状态：%@",dic);
                }
                    break;
                case 0X0b://设备状态信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkAlert:B5]];
                    NSLog(@"获取到主机工作状态：%@",dic);
                }
                    break;
                case 0X0c://超级指令
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceSupercComd:B5]];
                    NSLog(@"超级指令：%@",dic);
                }
                    break;
                default:
                    break;
            }
            break;
        case 'W':
            switch (command) {
                case 0X00://写：恢复出厂设置
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X00]];
                    NSLog(@"写：恢复出厂设置：%@",dic);
                }
                    break;
                case 0X01://写：主机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X01]];
                    NSLog(@"写：主机信息：%@",dic);
                }
                    break;
                case 0X02://写：主机时间日期
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X02]];
                    NSLog(@"写：主机时间日期：%@",dic);
                }
                    break;
                case 0X03://写：开关风扇
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X03]];
                    NSLog(@"写：风扇负离子：%@",dic);
                }
                    break;
                 case 0X04://可用天数
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X04]];
                    NSLog(@"写：风扇负离子：%@",dic);
                }
                    break;
                case 0X05://写：无
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X05]];
                                      NSLog(@"写：精油信息：%@",dic);
                }
                    break;
                case 0X06://写：工作模式设置
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X06]];
                    NSLog(@"写：工作时间段：%@",dic);
                }
                    break;
                    break;
                case 0X07://写：工作档位
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X07]];
                    NSLog(@"写：工作档位：%@",dic);
                }
                    break;
                case 0X08://写：开关机
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X08]];
                    NSLog(@"写：开关机：%@",dic);
                }
                    break;
                case 0X09://写：设备锁控制信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X09]];
                    NSLog(@"写：设备锁控制信息：%@",dic);
                }
                    break;
                case 0X0a://写：工作状态只读
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X0a]];
                    NSLog(@"写：工作状态：%@",dic);
                }
                    break;
                case 0X0c://写：超级指令
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X0c]];
                    NSLog(@"写：超级指令：%@",dic);
                }
                    break;
                    
                case 0X13://开关机信息
                {
                     dic = [[NSMutableDictionary alloc]initWithDictionary:[self paseConfigResult:B5 withTagL:0X13]];
                    NSLog(@"教堂版开关机指令：%@",dic);
                }
                    break;
                    
              
                default:
                    break;
            }
            break;
        case 'S':
            switch (command) {
                case 0X00://上传：恢复出厂设置
                    NSLog(@"上传：恢复出厂设置：%@",B5);
                    break;
                case 0X01://上传：主机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceState:B5]];
                    NSLog(@"上传：主机信息：%@",dic);
                }
                    break;
                case 0X02://上传：主机时间日期
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceTime:B5]];
                    NSLog(@"设备主动上传：主机时间日期：%@",dic);
                }
                    
                    break;
                case 0X03://上传：风扇设置状况
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceFan:B5 withCommandType:0x03]];
                    NSLog(@"上风扇设置状况：%@",dic);
                    
                }
                    break;
                 case 0X04://可用天数
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceAvailables:B5]];
                    NSLog(@"设备主动上报可用天数：%@",dic);
                }
                    break;
                case 0X05://上传：精油状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceEssential:B5]];
                    NSLog(@"上传：精油状态：%@",dic);
                }
                    break;
                case 0X06://上传：工作模式设定信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkGap:B5]];
                    NSLog(@"上传：工作模式设定信息：%@",dic);
                }                    break;
                    break;
                case 0X07://上传：工作档位
                {
                     dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceGears:B5]];
                     NSLog(@"上传主机工作档位：%@",dic);
                }
                    break;
                case 0X08://上传：开关机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceOnOFF:B5 withCommandType:0X08]];
                    NSLog(@"上传：开关机信息：%@",dic);
                }
                    break;
                    
                case 0X09://上传：设备锁控制信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceLockState:B5]];
                    NSLog(@"上传：设备锁控制信息：%@",dic);
                }
                    break;
                case 0X0a://上传：工作状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkState:B5]];
                    NSLog(@"上传：工作状态：%@",dic);
                }
                    break;
                case 0X0b://上传：告警信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceWorkAlert:B5]];
                    NSLog(@"上传：告警信息：%@",dic);
                }
                    break;
                case 0X0c://上传 超级指令
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceSupercComd:B5]];
                    NSLog(@"上传：超级指令：%@",dic);
                }
                    break;
                    
                case 0X13://开关机信息
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceOnOFF:B5 withCommandType:0x13]];
                    NSLog(@"教堂版开关机指令：%@",dic);
                }
                    break;
                    
                case 0X14://风扇状态
                {
                    dic = [[NSMutableDictionary alloc]initWithDictionary:[self parseDeviceFan:B5 withCommandType:0x14]];
                    NSLog(@"教堂版开关机指令：%@",dic);
                }
                    break;
                    
           
             
                default:
                    break;
            }
            break;
        default:
            break;
    }
    if(dic!=nil){
        
        if(Type == 555)
        {
            [[NSNotificationCenter defaultCenter] postNotificationName:kOnLocRecvPipeSyncData object:@{@"device": iotID, @"payload" : dic}];
        }else{
            
            [[NSNotificationCenter defaultCenter] postNotificationName:kOnRecvPipeSyncData object:@{@"device": iotID, @"payload" : dic}];
        }
        
        
    }
    
}


#pragma mark 穆斯林设备状态主动上报 0x17
-(NSDictionary*)parseDeviceStateComd:(NSString*)command{
    //工作时段    0：未工作，1：时段1，2：时段2，3：时段3,4：时段4,5：时段5
    long workState = (long)strtoul([[command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);//
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x17), @"commandType",
                         @(workState), @"workState",nil];
    return  dic;
}
-(NSString*)fetchSSIDInfo{
    
    NSString *sidStr = @"";
           CFArrayRef ssidArray = CNCopySupportedInterfaces();
           if (ssidArray != nil) {
               CFDictionaryRef myDict = CNCopyCurrentNetworkInfo(CFArrayGetValueAtIndex(ssidArray, 0));
               if (myDict!=nil) {
                   NSDictionary *dict = (NSDictionary*)CFBridgingRelease(myDict);
                   sidStr = [dict valueForKey:@"SSID"];
               }
           }
           return sidStr;
    
}



#pragma mark 超级指令
-(NSDictionary*)parseDeviceSupercComd:(NSString*)command{

    
    long year           =  (long)strtoul([ [command substringWithRange:NSMakeRange(0,4)] UTF8String],0,16);//年 16进制
    long month          =  (long)strtoul([ [command substringWithRange:NSMakeRange(4,2)] UTF8String],0,16);
    long day            =  (long)strtoul([ [command substringWithRange:NSMakeRange(6,2)] UTF8String],0,16);
    long hour           =  (long)strtoul([ [command substringWithRange:NSMakeRange(8,2)] UTF8String],0,16);
    long minute         =  (long)strtoul([ [command substringWithRange:NSMakeRange(10,2)] UTF8String],0,16);
    long second         =  (long)strtoul([ [command substringWithRange:NSMakeRange(12,2)] UTF8String],0,16);
    long week           =  (long)strtoul([ [command substringWithRange:NSMakeRange(14,2)] UTF8String],0,16);
    
    //风扇状态
    long fanState       =  (long)strtoul([ [command substringWithRange:NSMakeRange(16,2)] UTF8String],0,16);
    //P10,P11:精油可用天数
    long availableDays       =  (long)strtoul([ [command substringWithRange:NSMakeRange(18,4)] UTF8String],0,16);
   
    //精油总容量
    long oliTotal   =  (long)strtoul([ [command substringWithRange:NSMakeRange(22,4)] UTF8String],0,16);
    
    //精油当前容量
    long oilSurplus   =  (long)strtoul([ [command substringWithRange:NSMakeRange(26,4)] UTF8String],0,16);
    //精油消耗速度
    long fuelConsumption =  (long)strtoul([ [command substringWithRange:NSMakeRange(30,2)] UTF8String],0,16);
    

    //P17-P26: 当前工作模式或下段工作模式
    long workState = (long)strtoul([ [command substringWithRange:NSMakeRange(32,2)] UTF8String],0,10);
    long gap  = (long)strtoul([ [command substringWithRange:NSMakeRange(34,2)] UTF8String],0,16);
    int selGap= gap&0x01;
    Boolean isSelGap = selGap==1?YES:NO;
    long curweek = gap&0xfe;//当前工作星期或下段工作星期：
    
    //起始时间、小时分钟
    int hourStar    = (int)strtoul([ [command substringWithRange:NSMakeRange(36,2)] UTF8String],0,16);
    int minuteStar  = (int)strtoul([ [command substringWithRange:NSMakeRange(38,2)] UTF8String],0,16);
    
    //结束时间、小时分钟
    int hourStop    = (int)strtoul([ [command substringWithRange:NSMakeRange(40,2)] UTF8String],0,16);
    int minuteStop  = (int)strtoul([ [command substringWithRange:NSMakeRange(42,2)] UTF8String],0,16);
    
    
    //开多少秒
    long workGap = (long)strtoul([ [command substringWithRange:NSMakeRange(44,4)] UTF8String],0,16);
      //停多少秒
    long stopGap = (long)strtoul([ [command substringWithRange:NSMakeRange(48,4)] UTF8String],0,16);

    //P27:当前档位
    int gears =(int)strtoul([ [command substringWithRange:NSMakeRange(52,2)] UTF8String],0,16);
    
    
    //P28:开关机信息
    int powerState = (int)strtoul([ [command substringWithRange:NSMakeRange(54,2)] UTF8String],0,16);
    //P29:设备锁状态
    int lock = (int)strtoul([ [command substringWithRange:NSMakeRange(56,2)] UTF8String],0,16);
    
    
    
    //P21-P24:有无异常状态
    //雾化 0、雾化正常，1、雾化异常
    long atomizationErrState = (long)strtoul([ [command substringWithRange:NSMakeRange(58,2)] UTF8String],0,10);
    
    //0、气泵正常，1、气泵异常
    long  airErrPump    = (long)strtoul([ [command substringWithRange:NSMakeRange(60,2)] UTF8String],0,10);
    //0、风机正常，1、风机异常
    long fanErrState      = (long)strtoul([ [command substringWithRange:NSMakeRange(62,2)] UTF8String],0,10);
    
    //0、电压正常，1、电压过低或电量不足
    long voltageErrState      = (long)strtoul([ [command substringWithRange:NSMakeRange(64,2)] UTF8String],0,10);
    
    
    
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x0c), @"commandType",
                         @(year), @"year",
                         @(month), @"month",
                         @(day), @"day",
                         @(hour), @"hour",
                         @(minute), @"minute",
                         @(second), @"second",
                         @(week), @"week",
                         
                         @(fanState), @"fanState",
                         
                         @(oliTotal), @"oliTotal",
                         @(oilSurplus), @"oilSurplus",
                         @(fuelConsumption), @"fuelConsumption",
                         @(availableDays), @"availableDays",
                         
                         
                         
                         @(powerState), @"powerState",
                         @(lock), @"lock",
                         
                         //P14-P20:当前工作状态
                         @(workState), @"workState",
                         @(isSelGap), @"isSelGap",
                         @(curweek), @"curweek",
                         @(hourStar), @"hourStar",
                         @(minuteStar), @"minuteStar",
                         @(hourStop), @"hourStop",
                         @(minuteStop), @"minuteStop",
                         @(workGap), @"workGap",
                         @(stopGap), @"stopGap",
                         @(gears), @"gears",//P27:当前档位
                         //P21-P24:有无异常状态
                         @(atomizationErrState), @"atomizationErrState",
                         @(airErrPump), @"airErrPump",
                         @(fanErrState), @"fanErrState",
                         @(voltageErrState), @"voltageErrState",
                      

                         nil];
    return  dic;
    
}


#pragma mark 报警指令解析
-(NSDictionary*)parsePushMsgComd:(NSString*)command withIoitID:(NSString*)iotID{

    //00010000
    //P21-P24:有无异常状态
    //雾化 0、雾化正常，1、雾化异常
    long atomizationErrState = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,10);
    
    //0、气泵正常，1、气泵异常
    long  airErrPump    = (long)strtoul([ [command substringWithRange:NSMakeRange(2,2)] UTF8String],0,10);
    //0、风机正常，1、风机异常
    long fanErrState      = (long)strtoul([ [command substringWithRange:NSMakeRange(4,2)] UTF8String],0,10);
    //0、电压正常，1、电压过低或电量不足
    long voltageErrState      = (long)strtoul([ [command substringWithRange:NSMakeRange(6,2)] UTF8String],0,10);
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         iotID, @"iotid",
                         @(atomizationErrState), @"atomizationErrState",
                         @(airErrPump), @"airErrPump",
                         @(fanErrState), @"fanErrState",
                         @(voltageErrState), @"voltageErrState",
                         nil];
    return  dic;
    
}


#pragma mark 上传：告警信息
-(NSDictionary*)parseDeviceWorkAlert:(NSString*)command{
    //雾化 0、雾化正常，1、雾化异常
    long atomizationState = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,10);
    
    //0、气泵正常，1、气泵异常
    long  airPump    = (long)strtoul([ [command substringWithRange:NSMakeRange(2,2)] UTF8String],0,10);
    //0、风机正常，1、风机异常
    long fanState      = (long)strtoul([ [command substringWithRange:NSMakeRange(4,2)] UTF8String],0,10);
    
    //0、电压正常，1、电压过低或电量不足
    long voltageState      = (long)strtoul([ [command substringWithRange:NSMakeRange(6,2)] UTF8String],0,10);
    
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x0B), @"commandType",
                         @((atomizationState==0)?NO:YES), @"atomizationState",
                         @((airPump==0)?NO:YES), @"airErrPump",
                         @((fanState==0)?NO:YES), @"fanErrState",
                         @((voltageState==0)?NO:YES), @"voltageErrState",
                         nil];
    return  dic;
}
-(NSDictionary*)paseConfigResult:(NSString*)command withTagL:(int)commandTag{
    
    NSString*result =  [self convertHexStrToString:[command substringWithRange:NSMakeRange(0,command.length)]];
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(commandTag), @"commandType",
                         result, @"result",nil];
    return  dic;
}

-(NSDictionary*)parseDeviceState:(NSString*)command{
    
    //设备类型：1:圆屏无档位，2：常规无档位，3：有档位
    long deviceType = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    
    NSString*deviceName =    [command substringWithRange:NSMakeRange(2,command.length-2)];
    deviceName =  [self convertHexStrToString:deviceName];
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x01), @"commandType",
                         @(deviceType),@"deviceType",
                         @"R", @"operate",
                         deviceName, @"deviceName",
                         nil];
    return  dic;
}
-(NSDictionary*)parseDeviceTime:(NSString*)command{
    
    
    
    long year           =  (long)strtoul([ [command substringWithRange:NSMakeRange(0,4)] UTF8String],0,16);//年 16进制
    long month          =  (long)strtoul([ [command substringWithRange:NSMakeRange(4,2)] UTF8String],0,16);
    long day            =  (long)strtoul([ [command substringWithRange:NSMakeRange(6,2)] UTF8String],0,16);
    long hour           =  (long)strtoul([ [command substringWithRange:NSMakeRange(8,2)] UTF8String],0,16);
    long minute         =  (long)strtoul([ [command substringWithRange:NSMakeRange(10,2)] UTF8String],0,16);
    long second         =  (long)strtoul([ [command substringWithRange:NSMakeRange(12,2)] UTF8String],0,16);
    long week           =  (long)strtoul([ [command substringWithRange:NSMakeRange(14,2)] UTF8String],0,16);
    
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x02), @"commandType",
                         @(year), @"year",
                         @(month), @"month",
                         @(day), @"day",
                         @(hour), @"hour",
                         @(minute), @"minute",
                         @(second), @"second",
                         @(week), @"week",
                         nil];
    return  dic;
}
- (NSData *)hexToBytes:(NSString *)str
{
    NSMutableData* data = [NSMutableData data];
    int idx;
    for (idx = 0; idx+2 <= str.length; idx+=2) {
        NSRange range = NSMakeRange(idx, 2);
        NSString* hexStr = [str substringWithRange:range];
        NSScanner* scanner = [NSScanner scannerWithString:hexStr];
        unsigned int intValue;
        [scanner scanHexInt:&intValue];
        [data appendBytes:&intValue length:1];
    }
    return data;
}
-(NSString*)hex2AscStr:(NSString*)hexString{
    NSMutableString *ascStr =[[NSMutableString alloc]initWithCapacity:0]; //A
    for (int i =0; i<hexString.length; i++) {
        int asciiCode = [hexString characterAtIndex:i]; //65
        [ascStr appendString:[NSString stringWithFormat:@"%02x",asciiCode]]; //A
    }
    return ascStr;
}
#pragma MARK 设备锁控制信息
-(NSDictionary*)parseDeviceLockState:(NSString*)command{
    long openState = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    Boolean isOpen      =  (openState==1)?YES:NO;
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x09), @"commandType",
                         @(isOpen), @"isLock",
                         nil];
    return  dic;
}


#pragma MARK 风扇开关状态
-(NSDictionary*)parseDeviceFan:(NSString*)command withCommandType:(int)commandType{
    long openState = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    Boolean isOpen      =  (openState==1)?YES:NO;
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(commandType), @"commandType",
                         @(isOpen), @"isOpen",
                         nil];
    return  dic;
}

#pragma MARK 可用天数
-(NSDictionary*)parseDeviceAvailables:(NSString*)command{
    long available = (long)strtoul([ [command substringWithRange:NSMakeRange(0,4)] UTF8String],0,16);
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x04), @"commandType",
                         @(available), @"availableDays",
                         nil];
    return  dic;
}
#pragma MARK 精油配置参数
-(NSDictionary*)parseDeviceEssential:(NSString*)command{
    //精油总量
    long oilTotalValue = (long)strtoul([ [command substringWithRange:NSMakeRange(0,4)] UTF8String],0,16);
    //精油余量
    long oilMarginValue = (long)strtoul([ [command substringWithRange:NSMakeRange(4,4)] UTF8String],0,16);
    //精油消耗速度
    long  fuelDonsumption =(long)strtoul([ [command substringWithRange:NSMakeRange(8,2)] UTF8String],0,16);

    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x05), @"commandType",
                         @(oilTotalValue),   @"oliTotal",
                         @(oilMarginValue),  @"oilSurplus",
                         @(fuelDonsumption), @"fuelConsumption",
                         nil];
    return  dic;
}
#pragma MARK 工作模式设定信息
//

/*
 
 
 01 7f 08 00 16 00 01 41
 02 7f 00 00 00 00 01 3c
 03 7f 00 00 00 00 01 3c
 04 7f 00 00 00 00 01 3c
 05 7f 00 00 00 00 01 3c
 
 
 
 */
-(NSDictionary*)parseDeviceWorkGap:(NSString*)command{
    NSMutableArray * workModleArray = [[NSMutableArray alloc]initWithCapacity:0];
    int count = (int)command.length/22;
    int nc = command.length%22;
    if(nc == 0 &&  count>0)
    {
        for(int i =0;i< count;i++){
            NSMutableDictionary*tempDic = [[NSMutableDictionary alloc]initWithCapacity:0];
            //模式标志 1-5表示模式一到模式五
            int modleType = (int)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2,2)] UTF8String],0,16);
            long week = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+2,2)] UTF8String],0,16);
            
            
            //起始时间
            long hourStar    = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+4,2)] UTF8String],0,16);
            long minuteStar  = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+6,2)] UTF8String],0,16);
            
            //结束时间
            long hourEnd      = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+8,2)] UTF8String],0,16);
            long minuteEnd    = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+10,2)] UTF8String],0,16);
            
            //是否开启
            long tag = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+12,2)] UTF8String],0,16);
            Boolean isAction = (tag==1)?YES:NO;
            
            
            //开多少秒
            long workGap = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+14,4)] UTF8String],0,16);
            
            //停多少秒
            long stopGap = (long)strtoul([ [command substringWithRange:NSMakeRange((i*11)*2+18,4)] UTF8String],0,16);
            
            [tempDic setObject:@(modleType) forKey:@"modleType"];
            [tempDic setObject:@(week) forKey:@"curweek"];
            [tempDic setObject:@(hourStar) forKey:@"hourStar"];
            [tempDic setObject:@(minuteStar) forKey:@"minuteStar"];
            [tempDic setObject:@(hourEnd) forKey:@"hourStop"];
            [tempDic setObject:@(minuteEnd) forKey:@"minuteStop"];
            [tempDic setObject:@(isAction) forKey:@"isAction"];
            [tempDic setObject:@(workGap) forKey:@"workGap"];
            [tempDic setObject:@(stopGap) forKey:@"stopGap"];
            
            [workModleArray addObject:tempDic];
            
        }
        NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                             @(0x06), @"commandType",
                             workModleArray, @"workModleArray",
                             nil];
        return  dic;
        
        
    }
    return nil;
    
}

#pragma MARK 工作频率设定信息
-(NSDictionary*)parseDeviceFrequency:(NSString*)command{
    long week = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    long gap  = (long)strtoul([ [command substringWithRange:NSMakeRange(2,2)] UTF8String],0,16);
    int selGap= gap&0x03;
    if (selGap == 0x01) {
        //第一时段
        return nil;
    }else if(selGap == 0x02){
        //第二时段
        return nil;
    }
    //第一时段
    //工作时间
    long workTime1    = (long)strtoul([ [command substringWithRange:NSMakeRange(4,4)] UTF8String],0,16);
    long stopTime1    = (long)strtoul([ [command substringWithRange:NSMakeRange(8,4)] UTF8String],0,16);
    //第二时段
    //工作时间
    long workTime2    = (long)strtoul([ [command substringWithRange:NSMakeRange(12,4)] UTF8String],0,16);
    long stopTime2    = (long)strtoul([ [command substringWithRange:NSMakeRange(16,4)] UTF8String],0,16);
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x06), @"commandType",
                         @(week), @"curweek",
                         @(selGap), @"selGap",
                         @(workTime1), @"workTime1",
                         @(stopTime1), @"stopTime1",
                         @(workTime2), @"workTime2",
                         @(stopTime2), @"stopTime2",
                         nil];
    return  dic;
}


#pragma MARK 工作档位
-(NSDictionary*)parseDeviceGears:(NSString*)command{
    long modleTag = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x07), @"commandType",
                         @(modleTag), @"modleTag",
                         nil];
    return  dic;
}

#pragma MARK 开关机信息
-(NSDictionary*)parseDeviceOnOFF:(NSString*)command withCommandType:(int) commandType{
    long state = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,10);
    Boolean isOn      =  (state == 1)?YES:NO;
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(commandType), @"commandType",
                         @(isOn), @"isOn",
                         nil];
    return  dic;
}

-(void)test{
    
    
    /*
    a5aaac18570641434bc5ccca
    a5aaac975306017f0900130001009b003cc5ccca

    a5aaac42530a
     01 00 09 00 13 00 c5ccca

    */
//    NSString*test = @"a5aaac18570641434bc5cccaa5aaac975306017f0900130001009b003cc5cccaa5aaac42530a010009001300c5ccca";
//    NSData* xmlData = [MyDeviceInfHelper hexToData:test];
//    [self parseRemoteDataWithDeviceID:xmlData withDevice:@"q2dswwe"];
}





#pragma MARK 工作状态 01 00 09 00 13 00
-(NSDictionary*)parseDeviceWorkState:(NSString*)command{

    if(command.length != 20)
        return nil;
    
    //当前工作模式或下段工作模式
    long workState = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,10);
    
    long gap  = (long)strtoul([ [command substringWithRange:NSMakeRange(2,2)] UTF8String],0,16);
    int selGap= gap&0x01;
    Boolean isSelGap = selGap==1?YES:NO;
    long week = gap&0xfe;
    
    
    //起始时间、小时分钟
    int hourStar    = (int)strtoul([ [command substringWithRange:NSMakeRange(4,2)] UTF8String],0,16);
    int minuteStar  = (int)strtoul([ [command substringWithRange:NSMakeRange(6,2)] UTF8String],0,16);
    
    //结束时间、小时分钟
    int hourStop    = (int)strtoul([ [command substringWithRange:NSMakeRange(8,2)] UTF8String],0,16);
    int minuteStop  = (int)strtoul([ [command substringWithRange:NSMakeRange(10,2)] UTF8String],0,16);
    
    //开多少秒
    long workGap = (long)strtoul([ [command substringWithRange:NSMakeRange(12,4)] UTF8String],0,16);
    //停多少秒
    long stopGap = (long)strtoul([ [command substringWithRange:NSMakeRange(16,4)] UTF8String],0,16);
               
    
    
    
    
    
    //
    //    NSString* workTime= [NSString stringWithFormat:@"%02d:%02d -- %02d:%02d",hourStar,minuteStar,hourStop,minuteStop];
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x0a), @"commandType",
                         @(workState), @"workState",
                         @(isSelGap), @"isSelGap",
                         @(week), @"curweek",
                         @(hourStar), @"hourStar",
                         @(minuteStar), @"minuteStar",
                         
                         @(hourStop), @"hourStop",
                         @(minuteStop), @"minuteStop",
                         
                         @(workGap), @"workGap",
                         @(stopGap), @"stopGap",
                         nil];
    return  dic;
}






#pragma mark 上传：主机信息
-(NSDictionary*)SendDeviceState:(NSString*)command{
    
    long deviceType = (long)strtoul([ [command substringWithRange:NSMakeRange(0,2)] UTF8String],0,16);
    
    
    
    NSString*pswd       =  [self doPswdPase:[command substringWithRange:NSMakeRange(2,8)]];;
    NSString*deviceName =    [command substringWithRange:NSMakeRange(10,command.length-10)];
    deviceName =  [self convertHexStrToString:deviceName];
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         @(0x01), @"commandType",
                         @(deviceType),@"deviceType",
                         pswd, @"pswd",
                         @"R", @"operate",
                         deviceName, @"deviceName",
                         nil];
    return  dic;
}



- (NSString *)convertDataToHexStr:(NSData *)data {
    if (!data || [data length] == 0) {
        return @"";
    }
    NSMutableString *string = [[NSMutableString alloc] initWithCapacity:[data length]];
    
    if (@available(iOS 7.0, *)) {
        [data enumerateByteRangesUsingBlock:^(const void *bytes, NSRange byteRange,BOOL *stop) {
            unsigned char *dataBytes = (unsigned char*)bytes;
            for (NSInteger i =0; i < byteRange.length; i++) {
                NSString *hexStr = [NSString stringWithFormat:@"%x", (dataBytes[i]) &0xff];
                if ([hexStr length] == 2) {
                    [string appendString:hexStr];
                } else {
                    [string appendFormat:@"0%@", hexStr];
                }
            }
        }];
    } else {
        // Fallback on earlier versions
    }
    
    return string;
}
//将十六进制的字符串转换成NSString则可使用如下方式:
- (NSString *)doPswdPase:(NSString *)str {
    if (!str || [str length] == 0) {
        return nil;
    }
    if ([str isEqualToString:@"2a2a2a2a"]) {
        return @"****";
    }
    
    int t1 = [[str substringWithRange:NSMakeRange(0, 2)] intValue];
    int t2 = [[str substringWithRange:NSMakeRange(2, 2)] intValue];
    int t3 = [[str substringWithRange:NSMakeRange(4, 2)] intValue];
    int t4 = [[str substringWithRange:NSMakeRange(6, 2)] intValue];
    
    NSString *string = [NSString stringWithFormat:@"%d%d%d%d",t1,t2,t3,t4];
    return string;
}

//将十六进制的字符串转换成NSString则可使用如下方式:
- (NSString *)convertHexStrToString:(NSString *)str {
    if (!str || [str length] == 0) {
        return nil;
    }
    
    NSMutableData *hexData = [[NSMutableData alloc] initWithCapacity:8];
    NSRange range;
    if ([str length] % 2 == 0) {
        range = NSMakeRange(0, 2);
    } else {
        range = NSMakeRange(0, 1);
    }
    for (NSInteger i = range.location; i < [str length]; i += 2) {
        unsigned int anInt;
        NSString *hexCharStr = [str substringWithRange:range];
        NSScanner *scanner = [[NSScanner alloc] initWithString:hexCharStr];
        
        [scanner scanHexInt:&anInt];
        NSData *entity = [[NSData alloc] initWithBytes:&anInt length:1];
        [hexData appendData:entity];
        
        range.location += range.length;
        range.length = 2;
    }
    NSString *string = [[NSString alloc]initWithData:hexData encoding:NSUTF8StringEncoding];
    return string;
}



-(int)singleDog:(NSData*) nums{
    NSUInteger length = nums.length;
    int singleDog = 0;
    Byte *sourceDataPoint = (Byte *)[nums bytes];  //取需要加密的数据的Byte数组
    for (int idx = 0; idx < length; idx++) {
        singleDog ^= sourceDataPoint[idx];
    }
    return singleDog;
}

-(NSString *)generatePackage:(int)type andCommand:(int)command andParameter:(NSString*)parameter{
    NSString*B1 = COMMAND_HEAD;//NSString
    NSString*B3 = [NSString stringWithFormat:@"%02x",type];//指令类型
    NSString*B4 = [NSString stringWithFormat:@"%02x",command];//指令
    NSString*B5 = parameter;//参数
    NSString*B6 = COMMAND_END;//帧尾部
    
    NSMutableString *commandStr = [[NSMutableString alloc] initWithString:B3];
    [commandStr appendString:B4];
    [commandStr appendString:B5];
    
    NSData*commandPacket = [self hexToBytes:commandStr];
    NSString*B2 = [NSString stringWithFormat:@"%02x",[self singleDog:commandPacket]];
    
    NSMutableString *PacketStr = [[NSMutableString alloc] initWithString:B1];
    [PacketStr appendString:B2];
    [PacketStr appendString:commandStr];
    [PacketStr appendString:B6];
    

    return [PacketStr copy];
    
}


+(int)conversionWeekDay:(int) weekDay{
    int result = -1;
    switch (weekDay) {
        case 1:
            result = 7;
            break;
        case 2:
            result = 1;
            break;
        case 3:
            result = 2;
            break;
        case 4:
            result = 3;
            break;
        case 5:
            result = 4;
            break;
        case 6:
            result = 5;
            break;
        case 7:
            result = 6;
            break;
        default:
            break;
    }
    
    return result;
}









@end
